program read_data

  use gmt

  implicit none
  integer :: i,j, id, jd, stat
  real :: dlat, dlon
  real(8) :: lon_min, lon_max, lat_min, lat_max
  integer :: nx, ny
  integer :: nxlon, nylat, dlond, dlatd, nxstar, nystar
  real, allocatable :: lon(:), lat(:)
  integer, allocatable, dimension(:) :: fname_lon, fname_lat
  integer*2, allocatable :: height(:,:)
  real, allocatable :: height_r(:,:)
  character(4) :: out_filename
  character(11) :: src_filename
  character(3) :: clon
  character(2) :: clat

!-- read the namelist ---
namelist /input /dlon,dlat,out_filename,lon_min,lon_max,lat_min,lat_max
read(5,input)
nx=int(lon_max-lon_min)*1200+1
ny=int(lat_max-lat_min)*1200+1

!-- calc the array numbers ---
  nxlon=1201
  nylat=1201

!-- calc the difference of degree value ---
  dlond=int(lon_max-lon_min)
  dlatd=int(lat_max-lat_min)

!-- allocate the array ---
  allocate(lon(nx))
  allocate(lat(ny))
  allocate(height(nx,ny))
  allocate(height_r(nx,ny))
  allocate(fname_lon(dlond))
  allocate(fname_lat(dlatd))

!-- name the filename_degree ---
  fname_lon   &
  &  =(/((int(lon_min)+(i-1)),i=1,int(lon_max)-int(lon_min))/)
  fname_lat   &
  &  =(/((int(lat_min)+(i-1)),i=1,int(lat_max)-int(lat_min))/)

!-- substitute value from position array ---
  lon=(/((lon_min+dlon*real(i-1)/3600.0),i=1,nx)/)
  lat=(/((lat_min+dlat*real(i-1)/3600.0),i=1,ny)/)

!-- name the reading the file name ---
nxstar=1
nystar=1

do i=1,dlond
   do j=dlatd,1,-1
      write(clon,'(i3.3)') fname_lon(i)
      write(clat,'(i2.2)') fname_lat(j)
      write(*,*) fname_lon(i), fname_lat(j)
      src_filename='N'//clat//'E'//clon//'.hgt'
      write(*,*) 'read the file name is', src_filename
write(*,*) nxstar,nystar,nxlon,nylat
      call read_file(src_filename,nxlon-nxstar+1, &
   &                 nylat-nystar+1,height(nxstar:nxlon,nystar:nylat))

      nystar=nystar+1200
      nylat=nylat+1200

   end do
   nystar=1
   nylat=1201
   nxstar=nxstar+1200
   nxlon=nxlon+1200
end do

  height_r=real(height)

  stat=grd_create( 'form.grd', height_r, (/lon_min,lon_max/), &
   &     (/lat_min,lat_max/), (/(1.0d0/1200.0d0),(1.0d0/1200.0d0)/) )
!  call make_form('form',nx,ny,lon,lat,height)

  deallocate(lon)
  deallocate(lat)
  deallocate(height)
  deallocate(height_r)
  deallocate(fname_lon)
  deallocate(fname_lat)

end program read_data

subroutine read_file(input_file, nx, ny, height)
  implicit none
  integer :: i,j
  integer, intent(in) :: nx, ny
  character(*), intent(in) :: input_file
  integer*2, intent(inout) :: height(nx,ny)

  open(unit=13,file=input_file,access='direct',recl=2*nx,status='old')

  do j=1,ny
     read(13,rec=j) (height(i,j),i=1,nx)  ! STRM
  end do

  close(unit=13,status='keep')

end subroutine

subroutine make_form(output_file, nx, ny, lon, lat, height)
  implicit none
  integer :: i,j
  integer, intent(in) :: nx, ny
  character(*), intent(in) :: output_file
  integer*2, intent(in) :: height(nx,ny)
  real, intent(in) :: lon(nx), lat(ny)

  open(unit=14,file=output_file//'.dat',status='unknown')

  do j=1,ny
     do i=1,nx
        write(14,*) lon(i), lat(j), height(i,ny-j+1)
     end do
  end do

  close(unit=14,status='keep')

end subroutine
